<?php
if(iCMSa!=1 || !admit('DB')) exit;
require LANG_DIR.'admAll.php';

#Tytu strony
$content->title = $lang['dbcopy'];

#Funkcje
switch($db_db)
{
	case 'mysql':
		$type = 'mysql';
		$show = 'SHOW TABLES';
		break;
	case 'sqlite':
		$type = 'sqlite';
		$show = 'SELECT name FROM sqlite_master WHERE type="table" ORDER BY name';
		break;
	default:
		$content->info('Cannot parse database type.'); return 1;
}

#Tworzenie
if(isset($_POST['tab']))
{
	$n="\n";
	@set_time_limit(50);

	#Typ + kompresja?
	if(isset($_POST['gz']))
	{
		header('Content-type: application/x-gzip'); $ex='.sql.gz';
	}
	else
	{
		header('Content-type: text/plain'); $ex='.sql';
	}
	header('Content-Disposition: attachment; filename='.
		str_replace( array('?','*',':','\\','/','<','>','|','"'),'',strftime('%Y-%m-%d')).$ex);

	#Kompresja GZ?
	if(isset($_POST['gz'])) ob_start('ob_gzhandler'); else ob_start();

	#Dodaj gravis do nazw wasnych (MySQL)
	if($type === 'mysql') $db->exec('SET SQL_QUOTE_SHOW_CREATE=1');

	#Nagwek - komentarz
	echo '#'.$cfg['title'].' - Data Backup ('.strftime('%Y-%m-%d').')'.$n;
	echo '#Database: '.$db_d.$n;
	echo '#----------'.$n.$n;

	#Tabele
	foreach($_POST['tab'] as $tab)
	{
		#Optymalizuj
		if($type === 'sqlite')
		{
			$db->exec('VACUUM '.$tab);
		}
		else
		{
			$db->query('OPTIMIZE LOCAL TABLE '.$tab)->fetchAll(3);
		}

		#Tworzenie tabeli
		if(isset($_POST['create']))
		{
			echo '#Creating table '.$tab.$n;

			#Usuwanie?
			if(isset($_POST['del'])) echo 'DROP TABLE IF EXISTS `'.$tab.'`;'.$n;

			#Pobierz polecenie
			if($type === 'sqlite')
			{
				echo $db->query('SELECT sql FROM sqlite_master WHERE name="'.$tab.'"') -> fetchColumn() .';'.$n.$n;
			}
			else
			{
				echo $db->query('SHOW CREATE TABLE '.$tab)->fetchColumn(1).';'.$n.$n;
			}

			#Wypu dane
			ob_flush();
		}

		#Dane
		$all = $db->query('SELECT * FROM '.$tab);
		$all -> setFetchMode(3);
		echo '#Table data for '.$tab.$n;

		#Wartoci pl
		foreach($all as $row)
		{
			echo 'INSERT INTO `'.$tab.'` VALUES ('.join(',',array_map(array($db,'quote'),$row)).');'.$n;
			ob_flush(); //Zwolnij pami
		}
		unset($ile,$all,$row);
		echo $n;
		ob_flush(); //Zwolnij pami
	}

	#Zakocz
	ob_end_flush();
	exit;
}

#TABELE
$list = $db->query($show) -> fetchAll(7); //COLUMN
$tabs = '';

foreach($list as $tab)
{
	$tabs .= '<option>'.$tab.'</option>';
}

#FORM
$content->info($lang['dbInfo']);
$content->data = array(
	'tables' => $tabs,
	'gz'     => function_exists('gzopen')
);
