CREATE TABLE IF NOT EXISTS `f3_acl` (
`UID` KEY INT NOT NULL,
`CatID` KEY INT NOT NULL,
`type` VARCHAR(9) NOT NULL);

CREATE INDEX IF NOT EXISTS ID ON f3_acl (UID,CatID);

CREATE TABLE IF NOT EXISTS `f3_admmenu` (
`ID` VARCHAR(9) PRIMARY KEY NOT NULL,
`text` VARCHAR(30) NOT NULL,
`file` VARCHAR(30) NOT NULL,
`menu` TINYINT NOT NULL,
`rights` TINYINT NOT NULL);

CREATE TABLE IF NOT EXISTS `f3_answers` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`IDP` INT NOT NULL,
`seq` INT NOT NULL DEFAULT 0,
`a` VARCHAR(200),
`num` INT NOT NULL DEFAULT 0);

CREATE INDEX IF NOT EXISTS p ON f3_answers (IDP);

CREATE TABLE IF NOT EXISTS `f3_arts` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`cat` INT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`dsc` TEXT NOT NULL,
`date` datetime,
`author` VARCHAR(50) NOT NULL,
`rate` TINYINT,
`access` TINYINT NOT NULL,
`priority` TINYINT NOT NULL,
`pages` TINYINT NOT NULL,
`ent` INT NOT NULL DEFAULT 0);

CREATE INDEX IF NOT EXISTS cat ON f3_arts (cat);

CREATE TABLE IF NOT EXISTS `f3_artstxt` (
`ID` INT NOT NULL,
`page` TINYINT NOT NULL,
`cat` INT NOT NULL,
`text` MEDIUMTEXT,
`opt` TINYINT NOT NULL,
PRIMARY KEY (ID,page));

CREATE TABLE IF NOT EXISTS `f3_banners` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`gen` TINYINT NOT NULL,
`name` VARCHAR(50),
`ison` TINYINT,
`code` TEXT);

CREATE TABLE IF NOT EXISTS `f3_cats` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`dsc` VARCHAR(255),
`access` VARCHAR(9) NOT NULL,
`type` TINYINT NOT NULL DEFAULT 5,
`sc` INT NOT NULL DEFAULT 0,
`sort` TINYINT NOT NULL DEFAULT 2,
`text` TEXT,
`num` INT NOT NULL DEFAULT 0,
`nums` INT NOT NULL DEFAULT 0,
`opt` TINYINT NOT NULL,
`lft` TINYINT NOT NULL,
`rgt` TINYINT NOT NULL);

CREATE INDEX IF NOT EXISTS sc ON f3_cats (sc);
CREATE INDEX IF NOT EXISTS pos ON f3_cats (lft,rgt);

CREATE TABLE IF NOT EXISTS `f3_comms` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`TYPE` TINYINT NOT NULL,
`CID` INT NOT NULL,
`access` TINYINT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`author` VARCHAR(50) NOT NULL,
`guest` TINYINT NOT NULL DEFAULT 1,
`ip` VARCHAR(20) NOT NULL,
`date` INT,
`text` TEXT);

CREATE INDEX IF NOT EXISTS th ON f3_comms (TYPE,CID);

CREATE TABLE IF NOT EXISTS `f3_confmenu` (
`ID` VARCHAR(50) NOT NULL,
`name` VARCHAR(50),
`lang` VARCHAR(5) NOT NULL,
`img` VARCHAR(230));

CREATE INDEX IF NOT EXISTS ID ON f3_confmenu (ID);

CREATE TABLE IF NOT EXISTS `f3_files` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`cat` INT NOT NULL,
`name` VARCHAR(50),
`author` VARCHAR(100),
`date` datetime,
`dsc` TEXT,
`file` VARCHAR(200),
`dls` INT NOT NULL DEFAULT 0,
`access` TINYINT NOT NULL,
`size` VARCHAR(50),
`priority` TINYINT NOT NULL,
`rate` TINYINT,
`fulld` MEDIUMTEXT);

CREATE INDEX IF NOT EXISTS cat ON f3_files (cat);

CREATE TABLE IF NOT EXISTS `f3_groups` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`dsc` TEXT,
`access` VARCHAR(3) NOT NULL,
`opened` TINYINT NOT NULL,
`who` INT NOT NULL DEFAULT 0,
`num` INT NOT NULL DEFAULT 0,
`date` INT);

CREATE TABLE IF NOT EXISTS `f3_groupuser` (
`u` INT NOT NULL,
`g` INT NOT NULL,
`date` INT,
PRIMARY KEY (u,g));

CREATE TABLE IF NOT EXISTS `f3_imgs` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`cat` INT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`dsc` TEXT,
`type` TINYINT NOT NULL,
`date` datetime,
`priority` TINYINT NOT NULL,
`access` TINYINT NOT NULL,
`rate` TINYINT,
`author` VARCHAR(50) NOT NULL,
`filem` VARCHAR(255) NOT NULL,
`file` VARCHAR(255) NOT NULL,
`size` VARCHAR(9) NOT NULL);

CREATE INDEX IF NOT EXISTS cat ON f3_imgs (cat);

CREATE TABLE IF NOT EXISTS `f3_links` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`cat` INT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`dsc` TEXT,
`access` TINYINT NOT NULL,
`adr` VARCHAR(255) NOT NULL,
`priority` TINYINT NOT NULL,
`count` INT NOT NULL DEFAULT 0,
`rate` TINYINT,
`nw` TINYINT NOT NULL DEFAULT 0);

CREATE INDEX IF NOT EXISTS cat ON f3_links (cat);

CREATE TABLE IF NOT EXISTS `f3_log` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`date` timestamp NOT NULL default CURRENT_TIMESTAMP,
`ip` VARCHAR(40),
`user` INT NOT NULL DEFAULT 0);

CREATE TABLE IF NOT EXISTS `f3_menu` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`seq` INT NOT NULL,
`text` VARCHAR(50) NOT NULL,
`disp` VARCHAR(3) NOT NULL,
`menu` INT NOT NULL,
`type` TINYINT NOT NULL,
`img` VARCHAR(200),
`value` TEXT);

CREATE TABLE IF NOT EXISTS `f3_mitems` (
`menu` INT NOT NULL,
`text` VARCHAR(50) NOT NULL,
`type` TINYINT NOT NULL DEFAULT 5,
`url` VARCHAR(255) NOT NULL,
`nw` TINYINT NOT NULL DEFAULT 0,
`seq` TINYINT NOT NULL DEFAULT 0);

CREATE TABLE IF NOT EXISTS `f3_news` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`cat` INT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`txt` TEXT,
`date` datetime,
`author` VARCHAR(50) NOT NULL,
`img` VARCHAR(255) NOT NULL DEFAULT '',
`comm` INT NOT NULL DEFAULT 0,
`access` TINYINT NOT NULL,
`opt` TINYINT NOT NULL DEFAULT 3);

CREATE INDEX IF NOT EXISTS cat ON `f3_news` (cat);

CREATE TABLE IF NOT EXISTS `f3_newstxt` (
`ID` INT NOT NULL,
`cat` INT NOT NULL,
`text` MEDIUMTEXT,
PRIMARY KEY (ID));

CREATE TABLE IF NOT EXISTS `f3_online` (
`IP` VARCHAR(40) PRIMARY KEY NOT NULL,
`user` INT NOT NULL,
`name` VARCHAR(50),
`time` timestamp NOT NULL default CURRENT_TIMESTAMP);

CREATE TABLE IF NOT EXISTS `f3_pages` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`access` VARCHAR(3) NOT NULL,
`opt` TINYINT NOT NULL,
`text` MEDIUMTEXT);

CREATE TABLE IF NOT EXISTS `f3_plugins` (
`ID` VARCHAR(30) NOT NULL,
`name` VARCHAR(50) NOT NULL);

CREATE TABLE IF NOT EXISTS `f3_pms` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`th` INT NOT NULL,
`topic` VARCHAR(50) NOT NULL,
`usr` INT NOT NULL,
`owner` INT NOT NULL,
`st` TINYINT NOT NULL,
`del` INT NOT NULL DEFAULT 0,
`date` INT NOT NULL,
`txt` TEXT);

CREATE INDEX IF NOT EXISTS th ON f3_pms (th);
CREATE INDEX IF NOT EXISTS o ON f3_pms (owner);

CREATE TABLE IF NOT EXISTS `f3_polls` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`name` VARCHAR(50) NOT NULL,
`q` VARCHAR(80) NOT NULL,
`ison` TINYINT NOT NULL,
`type` TINYINT NOT NULL,
`num` INT NOT NULL DEFAULT 0,
`access` VARCHAR(3) NOT NULL,
`date` datetime);

CREATE TABLE IF NOT EXISTS `f3_pollvotes` (
`user` VARCHAR(40) NOT NULL,
`ID` INT NOT NULL,
`date` date NOT NULL DEFAULT CURRENT_DATE);

CREATE TABLE IF NOT EXISTS `f3_rates` (
`type` TINYINT NOT NULL,
`ID` INT NOT NULL,
`mark` TINYINT NOT NULL DEFAULT 5,
`IP` VARCHAR(50) NOT NULL);

CREATE TABLE IF NOT EXISTS `f3_rss` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`auto` TINYINT NOT NULL DEFAULT 1,
`name` VARCHAR(50) NOT NULL DEFAULT '',
`dsc` VARCHAR(99) NOT NULL DEFAULT '',
`url` VARCHAR(80) NOT NULL DEFAULT '',
`lang` VARCHAR(3) NOT NULL DEFAULT 'en',
`cat` INT NOT NULL DEFAULT 0,
`num` INT NOT NULL DEFAULT 10);

CREATE TABLE IF NOT EXISTS `f3_tags` (
`tag` VARCHAR(50) NOT NULL DEFAULT '',
`TYPE` TINYINT NOT NULL DEFAULT 5,
`ID` INT NOT NULL DEFAULT 0,
`num` INT NOT NULL DEFAULT 0);

CREATE INDEX IF NOT EXISTS tag ON f3_tags (tag,TYPE,ID);

CREATE TABLE IF NOT EXISTS `f3_tmp` (
`KEYID` VARCHAR(50) NOT NULL PRIMARY KEY,
`UID` INT NOT NULL,
`type` VARCHAR(9) NOT NULL);

CREATE TABLE IF NOT EXISTS `f3_users` (
`ID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
`login` VARCHAR(50) UNIQUE NOT NULL,
`pass` CHAR(32) NOT NULL,
`mail` VARCHAR(80),
`sex` TINYINT NOT NULL DEFAULT 0,
`opt` TINYINT NOT NULL DEFAULT 2,
`lv` TINYINT NOT NULL DEFAULT 1,
`adm` TEXT,
`regt` INT,
`lvis` INT,
`pms` TINYINT NOT NULL DEFAULT 0,
`about` TEXT,
`mails` TINYINT NOT NULL DEFAULT 0,
`www` VARCHAR(200) NOT NULL DEFAULT '',
`city` VARCHAR(50) NOT NULL DEFAULT '',
`icq` VARCHAR(15),
`skype` VARCHAR(50),
`jabber` VARCHAR(60),
`tlen` VARCHAR(50),
`gg` INT,
`photo` VARCHAR(150));