<?php /* Klasa szablonw */
class Content
{
	public
		$file,
		$title,
		$head,
		$desc,
		$data = array(),
		$check = true,
		$cache = VIEW_DIR,
		$dir = SKIN_DIR;

	#Wywietl szablony
	function display()
	{
		#Udostpnij jzyk
		global $lang;

		#Informacja
		if(isset($this->info))
		{
			$info = $this->info;
			include $this->path('info', 1);
			if(!$this->data) return;
		}

		#Utwrz referencje, aby omin $this w szablonach
		foreach(array_keys($this->data) as $key)
		{
			$$key = &$this->data[$key];
		}

		#Kompiluj i wywietl
		if(is_array($this->file))
		{
			foreach($this->file as $f)
			{
				include $this->path($f);
			}
		}
		else
		{
			include $this->path($this->file);
		}
	}

	#Informacja
	function info($text, $links=array(), $class='info')
	{
		$this->info[] = array('text' => $text, 'links' => $links, 'class' => $class);
	}

	#Dodaj plik CSS
	function addCSS($file)
	{
		if(!strpos($file, '/'))
		{
			$file = SKIN_DIR.$file;
		}
		$this->head .= '<link rel="stylesheet" type="text/css" href="'.$file.'" />';
	}

	#Dodaj skrypt
	function addScript($file, $type='text/javascript')
	{
		$this->head .= '<script type="'.$type.'" src="'.$file.'"></script>';
	}

	#404
	function set404()
	{
		$this->title = 'Not Found';
		$this->file = '404';
		header('Gone', true, 410);
	}

	#Komunikat lub bd
	function message($info, $link=null)
	{
		if($info === (int)$info)
		{
			require LANG_DIR.'special.php';
			$info = $lang[$info];
		}
		global $lang;
		require $this->path('message', 1);
		exit;
	}

	#Kompiluj szablon
	function path($file, $sys=null)
	{
		if(!$sys && file_exists($this->dir . $file . '.html'))
		{
			$path  = $this->dir;
			$cache = $this->cache;
		}
		elseif(file_exists(SKIN_DIR . $file . '.html'))
		{
			$path  = SKIN_DIR;
			$cache = VIEW_DIR;
		}
		elseif(file_exists('style/system/' . $file . '.html'))
		{
			$path  = './style/system/';
			$cache = './cache/system/';
		}
		else
		{
			exit('Cannot find template: '.$file.'.html');
		}

		#Sprawd dat modyfikacji
		if($this->check && filemtime($path . $file . '.html') > @filemtime($cache. $file . '.html'))
		{
			static $compiler;
			if(!isset($compiler))
			{
				include_once './lib/compiler.php';
				$compiler = new Compiler;
			}
			try
			{
				$compiler->compile($file, $path, $cache);
			}
			catch(Exception $e)
			{
				exit($e->getMessage());
			}
		}
		return $cache . $file . '.html';
	}
}