<?php /* API prywatnych wiadomoci - pamitaj o objciu operacji transakcj bazy danych */
class PM
{
	public
		$to,
		$text,
		$topic,
		$thread = 0,
		$sender = UID, //Tylko ID
		$status = 1,
		$exceptions;

	#Sprawd poprawno danych - uyj $errRef, jeli ju zdefiniowae tablic bdw
	function errors(&$errRef = null)
	{
		global $lang;

		#Tu zapisuj bdy
		if($errRef && is_array($errRef))
		{
			$error = &$errRef;
		}
		else
		{
			$error = array();
		}

		#Tre za duga?
		if(isset($this->text[20001])) $error[] = $lang['pm18'];

		#Skrzynka pena?
		if($this->inboxFull($this->to)) $error[] = $lang['pm21'];

		#Wyrzu bd
		if($error)
		{
			if($this->exceptions)
			{
				throw new Exception($error);
			}
			elseif($errRef)
			{
				return true;
			}
			else
			{
				return $error;
			}
		}
		return false; //FALSE gdy brak bdw
	}

	#Wylij wiadomo
	function send($force = false)
	{
		global $db;

		#Odbiorca
		if(!is_numeric($this->to)) $this->to = userID($this->to);

		#Gdy s bdy...
		if(!$force && $this->errors()) return false;

		#Zapytanie
		$q = $db->prepare('INSERT INTO '.PRE.'pms (th,topic,usr,owner,st,date,txt)
		VALUES (:th,:topic,:usr,:owner,:st,:date,:txt)');

		$q->execute( array(
			'owner' => $this->status > 2 ? $this->sender : $this->to,
			'usr'   => $this->status < 3 ? $this->sender : $this->to,
			'topic' => $this->topic,
			'txt'   => $this->text,
			'th'    => $this->thread,
			'st'    => $this->status,
			'date'  => $_SERVER['REQUEST_TIME']
		));

		#Zwiksz liczb nieodebranych wiadomoci
		if($this->status === 1) $db->exec('UPDATE '.PRE.'users SET pms=pms+1 WHERE ID='.$this->to);
	}

	#Zapisz wiadomo (domylnie - kopia robocza)
	function update($id, $force=false)
	{
		global $db;

		#Odbiorca
		if(!is_numeric($this->to)) $this->to = userID($this->to);

		$q = $db->prepare('UPDATE '.PRE.'pms SET th=:th, topic=:topic, usr=:usr,
		owner=:owner, st=:st, date=:date, txt=:txt WHERE owner=:you AND st=3 AND ID=:id');

		$q->execute( array(
			'you'   => UID,
			'id'    => $id,
			'th'    => $this->thread,
			'owner' => $this->status > 2 ? $this->sender : $this->to,
			'usr'   => $this->status < 3 ? $this->sender : $this->to,
			'topic' => $this->topic,
			'txt'   => $this->text,
			'st'    => $this->status,
			'date'  => $_SERVER['REQUEST_TIME']
		));

		#Zwiksz liczb nieodebranych wiadomoci
		if($this->status === 1) $db->exec('UPDATE '.PRE.'users SET pms=pms+1 WHERE ID='.$this->to);
	}

	#Czy skrzynka jest pena?
	function inboxFull($user=null)
	{
		if(!$user) $user = $this->to;
		return dbCount('pms WHERE owner='.(int)$user) >= $GLOBALS['cfg']['pmLimit'];
	}

	#Usu wiadomoci
	function delete($id)
	{
		if(is_array($id))
		{
			$in = array();
			foreach($id as $x) $in[] = (int)$x;
		}
		elseif(is_numeric($id))
		{
			$in = array($id);
		}
		else return false;

		$GLOBALS['db']->exec('DELETE FROM '.PRE.'pms WHERE ID IN ('.join(',', $in).')');
		return $GLOBALS['db']->rowCount(); //Zwr ilo usunitych wiadomoci
	}
}

#Pobierz ID uytkownika
function userID($login)
{
	global $db;

	if($id = (int)$db->query('SELECT ID FROM '.PRE.'users WHERE login='.$db->quote($login))->fetchColumn())
	{
		return $id;
	}
	else
	{
		throw new Exception($GLOBALS['lang']['pm20']);
	}
}